
//####################################################################\\
//                                                                    \\
//         FILE:   grafwin.h                                          \\
//                                                                    \\
//####################################################################\\

typedef LRESULT CALLBACK _export (*GWINPROC)(HWND, UINT, WPARAM, LPARAM);

typedef int      CONTROL;
typedef COLORREF COLOR;
typedef int      MEASURE;
typedef int      PIXEL;
typedef int      TIPS;

#define GR_AXISNO      0
#define GR_AXISCENTER  1
#define GR_AXISBEGIN   2
#define GR_AXISBEGINM  3
#define GR_AXISEND     4
#define GR_AXISENDM    5
#define GR_AXISZERO    6

const int GR_AREAINANDEX = 0;
#define GR_AREAINONLY   1
#define GR_AREAEXONLY   2
#define GR_AREAAUTO     3

const int GWS_MINIMIZED = 0;
const int GWS_MAXIMIZED = 1;
const int GWS_NORMAL    = 2;
const int GWS_CLOZED    = 3;
const int GWS_HIDED     = 4;

#define IZOLINES     0x1
#define IZOREGIONS   0x2

const int GWnPens = 10;
const int iPen0 = 0;
const int iPen1 = 1;
const int iPen2 = 2;
const int iPen3 = 3;
const int iPen4 = 4;
const int iPen5 = 5;
const int iPen6 = 6;
const int iPen7 = 7;
const int iPen8 = 8;
const int iPen9 = 9;

extern  COLOR  BLACK;
extern  COLOR  BLUE;
extern  COLOR  GREEN;
extern  COLOR  CYAN;
extern  COLOR  RED;
extern  COLOR  MAGENTA;
extern  COLOR  BROWN;
extern  COLOR  LIGHTGRAY;
extern  COLOR  DARKGRAY;
extern  COLOR  LIGHTBLUE;
extern  COLOR  LIGHTGREEN;
extern  COLOR  LIGHTCYAN;
extern  COLOR  LIGHTRED;
extern  COLOR  LIGHTMAGENTA;
extern  COLOR  YELLOW;
extern  COLOR  LIGHTYELLOW;
extern  COLOR  WHITE;
COMMON COLOR clr[18];

//####################################################################\\
class PENSTYLE
{
friend class GRAFWIN;
private:
  COLOR Color;
  int   Width;
  int   Style;
public:
  PENSTYLE (COLOR c, int w = 1, int s = PS_SOLID){
    Color = c;
    Width = w;
    Style = s;
  };
  PENSTYLE (void){
    Color = MAGENTA;
    Width = 1;
    Style = PS_SOLID;
  };
  COLOR GetColor (void) {return (Color);}
  int GetWidth (void) {return (Width);}
  int GetStyle (void) {return (Style);}
  void SetColor (COLOR c) {Color = c;}
  void SetWidth (int w) {Width = w;}
  void SetStyle (int s) {Style = s;}
  int ioDatas (RWFUNC, FILE*);
};

//####################################################################\\
class PIXRECT
{
friend class GRAFWIN;
public:
   PIXEL left;
   PIXEL top;
   PIXEL right;
   PIXEL bottom;
public:
   PIXRECT(PIXEL L, PIXEL T, PIXEL R, PIXEL B){
      left   = L;
      top    = T;
      right  = R;
      bottom = B;
   };
   PIXRECT ( PIXRECT & pr )
   {
      left   = pr.left;
      top    = pr.top;
      right  = pr.right;
      bottom = pr.bottom;
   };
   PIXRECT (void){
      left   = 1;
      top    = 1;
      right  = 800;
      bottom = 600;
   };
   PIXEL GetLeft   (void) { return ( left   );}
   PIXEL GetTop    (void) { return ( top    );}
   PIXEL GetRight  (void) { return ( right  );}
   PIXEL GetBottom (void) { return ( bottom );}

   void SetLeft   ( PIXEL L ) { left   = L;}
   void SetTop    ( PIXEL T ) { top    = T;}
   void SetRight  ( PIXEL R ) { right  = R;}
   void SetBottom ( PIXEL B ) { bottom = B;}
};


//####################################################################\\
class PIXSIZE
{
private:
  PIXEL hor, ver;
public:
  PIXSIZE(PIXEL x, PIXEL y){hor=x; ver=y;}
  PIXEL Geth(){return hor;}
  PIXEL Getv(){return ver;}
  void Seth(PIXEL x){hor=x;}
  void Setv(PIXEL y){ver=y;}
};

//####################################################################\\
class SEGM{
friend class SSEGM;
private:
  PIXEL pmin, pmax;
public:
  SEGM::SEGM(){pmin=0; pmax=4;}
  SEGM::SEGM(PIXEL x, PIXEL y){pmin=x; pmax=y;}
  int setSEGM(PIXEL x, PIXEL y){pmin=x; pmax=y; return TRUE;}
};

//####################################################################\\
class SSEGM{
friend class WINSTON;
friend class WINCOLORMAP;
private:
  PIXEL l, r, t, b;
public:
  SSEGM::SSEGM(PIXEL lm, PIXEL rm, PIXEL tm, PIXEL bm)
  {l=lm; r=rm; t=tm; b=bm;}
  SSEGM::SSEGM(SEGM hor, SEGM ver)
  {l=hor.pmin; r=hor.pmax; t=ver.pmin; b=ver.pmax;}
  SSEGM::SSEGM()
  {l=0; r=800; t=0; b=600;}
//  SSEGM & operator = ( SSEGM & ss){l=ss.l; r=ss.r; t=ss.t; b=ss.b;}
};

//####################################################################\\
class WINDPOS{
friend class WINSTON;
private:
  PIXEL CoordX;
  PIXEL CoordY;
  PIXEL LengthX;
  PIXEL LengthY;
public:
  WINDPOS (PIXEL cx, PIXEL cy, PIXEL lx, PIXEL ly){
     CoordX  = cx;
     CoordY  = cy;
     LengthX = lx;
     LengthY = ly;
  };
  WINDPOS (void){
    CoordX  = 1;
    CoordY  = 1;
    LengthX = 800;
    LengthY = 600;
  };
  PIXEL GetCoordX  (void) { return ( CoordX  );}
  PIXEL GetCoordY  (void) { return ( CoordY  );}
  PIXEL GetLengthX (void) { return ( LengthX );}
  PIXEL GetLengthY (void) { return ( LengthY );}
  void SetCoordX  ( PIXEL cx ) { CoordX  = cx;}
  void SetCoordY  ( PIXEL cy ) { CoordY  = cy;}
  void SetLengthX ( PIXEL lx ) { LengthX = lx;}
  void SetLengthY ( PIXEL ly ) { LengthY = ly;}
};

//####################################################################\\
class TIPSRECT
{
friend class GRAFWIN;
private:
   TIPS  left;
   TIPS  top;
   TIPS  right;
   TIPS  bottom;
public:
   TIPSRECT ( TIPS  L, TIPS  T, TIPS  R, TIPS  B ){
      left   = L;
      top    = T;
      right  = R;
      bottom = B;
   };
   TIPSRECT (void){left=1; top=1; right=1279; bottom = 1023;};
   TIPS GetLeft   (void) { return ( left   );}
   TIPS GetTop    (void) { return ( top    );}
   TIPS GetRight  (void) { return ( right  );}
   TIPS GetBottom (void) { return ( bottom );}
   void SetLeft   ( TIPS L ) { left   = L;}
   void SetTop    ( TIPS T ) { top    = T;}
   void SetRight  ( TIPS R ) { right  = R;}
   void SetBottom ( TIPS B ) { bottom = B;}
};

//####################################################################\\
class MATHRECT
{
friend class GRAFWIN;
private:
   double    MinX;
   double    MaxX;
   double    MinY;
   double    MaxY;
public:
   MATHRECT ( double L, double R, double B, double T ){
      MinX = L;
      MaxX = R;
      MinY = B;
      MaxY = T;
   };
   MATHRECT (void){
      MinX = -1.0;
      MaxX =  1.0;
      MinY = -1.0;
      MaxY =  1.0;
   };
   double GetMinX (void) { return ( MinX );}
   double GetMaxX (void) { return ( MaxX );}
   double GetMinY (void) { return ( MinY );}
   double GetMaxY (void) { return ( MaxY );}
   void SetMinX ( double x ) { MinX = x;}
   void SetMaxX ( double x ) { MaxX = x;}
   void SetMinY ( double y ) { MinY = y;}
   void SetMaxY ( double y ) { MaxY = y;}
};

//####################################################################\\
class COLORSCHEME
{
friend class GRAFWIN;
private:
   COLOR     Axis;
   COLOR     Grid;
   COLOR     Frame;
   COLOR     Fill;
   COLOR     Box;
public:
   COLORSCHEME (
      COLOR mAxis
   , COLOR mGrid  = GREEN
   , COLOR mFrame = LIGHTCYAN
   , COLOR mFill  = DARKGRAY
   , COLOR mBox   = LIGHTGRAY
     )
   {
      Axis  = mAxis ;
      Grid  = mGrid ;
      Frame = mFrame;
      Fill  = mFill ;
      Box   = mBox  ;
   };
   COLORSCHEME (void){
      Axis  = WHITE    ;
      Grid  = GREEN    ;
      Frame = LIGHTCYAN;
      Fill  = DARKGRAY ;
      Box   = LIGHTGRAY;
   }
   int ioDatas (RWFUNC);
   COLOR GetAxis  (void) { return Axis ;}
   COLOR GetGrid  (void) { return Grid ;}
   COLOR GetFrame (void) { return Frame;}
   COLOR GetFill  (void) { return Fill ;}
   COLOR GetBox   (void) { return Box  ;}
   void  SetAxis  ( COLOR a  ) { Axis  = a ;}
   void  SetGrid  ( COLOR g  ) { Grid  = g ;}
   void  SetFrame ( COLOR fr ) { Frame = fr;}
   void  SetFill  ( COLOR fi ) { Fill  = fi;}
   void  SetBox   ( COLOR b  ) { Box   = b ;}
};

//####################################################################\\
class AXSTYLE
{
friend class GRAFWIN;
private:
   char    * Name;
   int       nLargeTics;
   int       nSmallTics;
   int       Style;
   double      MathMin;
   double      MathMax;
   double      Step;
   int       nTag;
   int       nOrder;
   double      dOrder;
   double      Scale;
   double      MathAnotherAxisCoord;
   PIXEL     PixAxisCoord;
   int       nLargeTicsM;
   PIXEL     PixBorder1;
   PIXEL     PixBorder2;
public:
   AXSTYLE (char* mName,
     int       mnLargeTics    = 5
   , int       mnSmallTics    = 1
   , int       mStyle         = GR_AXISBEGIN
   , double    mMathMin       = -1.0
   , double    mMathMax       =  1.0
   , double    mStep          =  0.4
   , int       mnTag          = 4
   , int       mnOrder        = -1
   , double    mdOrder        =  0.1
   , double    mScale         =  1.0
   , double    mMathAnotherAxisCoord = 0.0
   , PIXEL     mPixAxisCoord  = 100
   , int       mnLargeTicsM   = 1
   , PIXEL     mPixBorder1    = 1
   , PIXEL     mPixBorder2    = 1
     ){
      Name          = mName         ;
      nLargeTics    = mnLargeTics   ;
      nSmallTics    = mnSmallTics   ;
      Style         = mStyle        ;
      MathMin       = mMathMin      ;
      MathMax       = mMathMax      ;
      Step          = mStep         ;
      nTag          = mnTag         ;
      nOrder        = mnOrder       ;
      dOrder        = mdOrder       ;
      Scale         = mScale        ;
      MathAnotherAxisCoord = mMathAnotherAxisCoord;
      PixAxisCoord  = mPixAxisCoord ;
      nLargeTicsM   = mnLargeTicsM  ;
      PixBorder1    = mPixBorder1   ;
      PixBorder2    = mPixBorder2   ;
   };
   AXSTYLE (void){
      Name          = "Default"   ;
      Style         = GR_AXISBEGIN;
      nLargeTics    = 5           ;
      nSmallTics    = 1           ;
      MathMin       = -1.0        ;
      MathMax       =  1.0        ;
      Step          =  0.4        ;
      nTag          =  4          ;
      nOrder        =  -1         ;
      dOrder        =  0.1        ;
      Scale         =  1.0        ;
      MathAnotherAxisCoord = 0.0  ;
      PixAxisCoord  = 100         ;
      nLargeTicsM   = 1           ;
      PixBorder1    = 1           ;
      PixBorder2    = 1           ;
   };
   int ioDatas(RWFUNC);
};

//####################################################################\\
class WINSTON{
public:
  GWINPROC GWinProc;
  HWND  WShWnd;
  HDC   WShDC;
  int   GWThisIndex;
  char* WSClassName;
  char* GWWindowTitle;
  WINDPOS GWWindPos;
  PIXRECT WSDefRect;
  RECT  WSRect;
  int   GWState;
  PAINTSTRUCT WSps;
  int WSDefWid;
  int WSDefHei;
  static int ScrDefWid;
  static int ScrDefHei;
  static int ScrPixWid;
  static int ScrPixHei;
  static PIXRECT WSScrPixRect;

// there is another constructor!
WINSTON::WINSTON(GWINPROC mgwp, HWND mGWhWnd, HDC mGWhDC,
   int      mGWThisIndex      =    0
,  char   * mGWClassName      = "Default"
,  char   * mGWWindowTitle    = "DefTitle"
,  PIXRECT  mWSDefRect = PIXRECT(0, 0, 36, 24)
,  int mState = GWS_NORMAL);
/*
WINSTON::WINSTON(GWINPROC mgwp, HWND mGWhWnd, HDC mGWhDC,
   int      mGWThisIndex   //    =    0
,  char   * mGWClassName   //    = "Default"
,  char   * mGWWindowTitle //  = "DefTitle"
,  PIXRECT  mWSDefRect     // = PIXRECT(0, 0, 36, 24)
,  int mState              //= GWS_NORMAL
   );
{
  GWinProc      = mgwp;
  WShWnd        = mGWhWnd;
  GWState       = GWS_CLOZED;
  WShDC         = mGWhDC;
  WSClassName   = mGWClassName;
  GWWindowTitle = mGWWindowTitle;
  GWThisIndex   = mGWThisIndex;
//???  GWWindPos     = WINDPOS(0,0,640,480);
  WSDefRect = mWSDefRect;
  WSSetDefSize(36, 24);
    WSRect.left = 0;
    WSRect.right= 640-1;
    WSRect.top = 0;
    WSRect.bottom = 480-1;
}
*/

WINSTON::WINSTON(GWINPROC mgwp, HWND mGWhWnd, HDC mGWhDC,
   int      mGWThisIndex      =    0
,  char   * mGWClassName      = "Default"
,  char   * mGWWindowTitle    = "DefTitle"
,  SSEGM  ds = SSEGM(0, 36, 0, 24)
,  int mState = GWS_NORMAL
,  PIXSIZE psize = PIXSIZE(24,24));


// there is another constructor!
/*
WINSTON::WINSTON(GWINPROC mgwp, HWND mGWhWnd, HDC mGWhDC,
   int      mGWThisIndex      // =    0
,  char   * mGWClassName      // = "Default"
,  char   * mGWWindowTitle    // = "DefTitle"
,  SSEGM  ds                  // = SSEGM(0, 36, 0, 24)
,  int mState                 // = GWS_NORMAL
,  PIXSIZE psize = PIXSIZE(24,24)              // = PIXSIZE(24,24)
);
{
  GWinProc      = mgwp;
  WShWnd        = mGWhWnd;
  GWState       = GWS_CLOZED;
  WShDC         = mGWhDC;
  WSClassName   = mGWClassName;
  GWWindowTitle = mGWWindowTitle;
  GWThisIndex   = mGWThisIndex;
//???  GWWindPos     = WINDPOS(0,0,640,480);
  WSDefRect = PIXRECT(ds.l, ds.t, ds.r, ds.b);
  WSSetDefSize(psize.Geth(), psize.Getv());
    WSRect.left = 0;
    WSRect.right= 640-1;
    WSRect.top = 0;
    WSRect.bottom = 480-1;
}
*/
ATOM WINSTON::WSRegisterClass (
   UINT style,
   int ClsExtra,
   int WndExtra,
   HINSTANCE hIn,
   HICON hic,
   HCURSOR hcu,
   HBRUSH hbr,
   LPCSTR Menu
   )
{
  WNDCLASS wc;
  memset(&wc, 0, sizeof(wc));
  wc.style = style;
  wc.lpfnWndProc = (WNDPROC) GWinProc;
  wc.cbClsExtra = ClsExtra;
  wc.cbWndExtra = WndExtra;
  wc.hInstance = hIn;
  wc.hIcon = hic;
  wc.hCursor = hcu;
  wc.hbrBackground = hbr;
  wc.lpszMenuName = Menu;
  wc.lpszClassName = (LPSTR)WSGetClassName();
  return RegisterClass (&wc);
}

HWND WINSTON::WSCreateWindow(HWND hWndParent, HINSTANCE hInstance){
  if(WShWnd==NULL) WShWnd = CreateWindow(WSClassName, GWWindowTitle,
    WS_OVERLAPPEDWINDOW,
    GWWindPos.GetCoordX(),  GWWindPos.GetCoordY(),
    GWWindPos.GetLengthX(), GWWindPos.GetLengthY(),
    hWndParent, 0, hInstance, NULL);
  if (WShWnd)
    GWState = GWS_NORMAL;
  else
    GWState = GWS_CLOZED;
  return WShWnd;
}
void WINSTON::WSShowWindow (int nCmdShow){ShowWindow(WShWnd, nCmdShow);}
char* WINSTON::WSGetClassName(void){ return WSClassName;}
void  WINSTON::WSSetClassName(char * Name){WSClassName = Name;}
HDC   WINSTON::WSGethDC(void){return WShDC;}
HWND WINSTON::WSGethWnd(void){return WShWnd;}
static PIXRECT WINSTON::WSGetScrPixRect(void)
{
  ScrPixWid = GetSystemMetrics( SM_CXSCREEN );
  ScrPixHei = GetSystemMetrics( SM_CYSCREEN );
  WSScrPixRect = PIXRECT(0,0, ScrPixWid, ScrPixHei);
  return WSScrPixRect;
}

int WINSTON::WSSetDefSize(int wx, int wy){
  WSDefWid = wx;
  WSDefHei = wy;
  return FALSE;
}

int WINSTON::WSSetWinPixPos(PIXRECT Usrct)
{
    GWSetCoordsLengths(
  Usrct.left + (Usrct.right -Usrct.left) * WSDefRect.left/ScrDefWid,
  Usrct.top  + (Usrct.bottom-Usrct.top ) * WSDefRect.top /ScrDefHei,
  (Usrct.right - Usrct.left)*(WSDefRect.right - WSDefRect.left)/ScrDefWid,
  (Usrct.bottom - Usrct.top)*(WSDefRect.bottom - WSDefRect.top)/ScrDefHei
  );
  return FALSE;
}
int WINSTON::WSSetWinPixPos(void){
  WSGetScrPixRect();
  WSSetWinPixPos(WSScrPixRect);
  return FALSE;
}

void WINSTON::WSSetThisIndex(int index){ GWThisIndex = index;}
int  WINSTON::WSGetThisIndex(void){ return GWThisIndex;}

HDC WINSTON::WSBeginPaint(HWND hWnd){
  WShWnd = hWnd;
  WShDC = BeginPaint (WShWnd, &WSps);
  GetClientRect(WShWnd, &WSRect);
  return WShDC;
}
void WINSTON::WSEndPaint(void){EndPaint (WShWnd, &WSps);}
BOOL WINSTON::WSUpdateWindow(void){return UpdateWindow(WShWnd);}

BOOL WINSTON::GWPostMessage00 ( UINT msg )
    {return PostMessage(WShWnd, msg, 0, 0);}

void GWSetCoordsLengths (int cx, int cy, int lx, int ly){
  GWWindPos.SetCoordX  (cx);
  GWWindPos.SetCoordY  (cy);
  GWWindPos.SetLengthX (lx);
  GWWindPos.SetLengthY (ly);
}

void GWGetCoordsLengths (int& cx, int& cy, int& lx, int& ly){
  cx=GWWindPos.GetCoordX();
  cy=GWWindPos.GetCoordY();
  lx=GWWindPos.GetLengthX();
  ly=GWWindPos.GetLengthY();
}

void WINSTON::GWMoveWindow (int cx, int cy, int lx, int ly, BOOL repaint)
  {MoveWindow ( WShWnd, cx, cy,lx, ly, repaint );}
void WINSTON::GWMoveWindow (BOOL repaint)
  {MoveWindow(WShWnd, GWWindPos.GetCoordX(),  GWWindPos.GetCoordY(),
                      GWWindPos.GetLengthX(), GWWindPos.GetLengthY(), repaint);}
                      
void WINSTON::GWDestroy(void){
  if (WShWnd) DestroyWindow(WShWnd);
  WShWnd = NULL;
  GWState = GWS_CLOZED;
}
void GWSetFocus(void){SetFocus(WShWnd);}
void GWInvalidateRgnNT(void){InvalidateRgn(WShWnd, NULL, TRUE);}
};

//####################################################################\\
class GRAFWIN
{
public:
  WINSTON* pws;
  static FONTMODEL   FontNumbers;
  static FONTMODEL   FontNames;
  static FONTMODEL   FontCaps;
private:
   char      * GWGraphTitle;
   PIXRECT     GWPRWnd;
   TIPSRECT    GWTipsRectContainer;
   PIXRECT     GWPRC;
   PIXRECT     GWPRB;
   PIXRECT     GWPRG;
   MATHRECT    GWMRD;
   MATHRECT    GWMRG;
   PENSTYLE    GWPenStyle[GWnPens];
   COLORSCHEME GWColorScheme;
   int         GWStyleGrid;
   AXSTYLE     GWASX;
   AXSTYLE     GWASY;
public:
GRAFWIN::GRAFWIN(
   WINSTON* mws
,  char   * mGWGraphTitle     // = "Title"
,  PIXRECT  mGWPRG            // = PIXRECT()
,  TIPSRECT mGWTRC            // = TIPSRECT()
,  MATHRECT mGWMRD            // = MATHRECT()
,  PENSTYLE mGWPS             // = PENSTYLE()
,  COLORSCHEME mGWCS          // = COLORSCHEME(WHITE, GREEN, LIGHTCYAN, DARKGRAY, LIGHTGRAY )          // Box
,  int      mGWStyleGrid      // =    1           //
,  AXSTYLE  mGWASX            // = AXSTYLE()
,  AXSTYLE  mGWASY            // = AXSTYLE()
  );
GRAFWIN::GRAFWIN(){
   MessageBox ( NULL , "Unexpected Constructor of GRAFWIN: No arguments.","Error",MB_OK);
   exit ( EXIT_FAILURE );
}
void GRAFWIN::GWEndPaint(void){pws->WSEndPaint();}
HDC GRAFWIN::GWBeginPaint(HWND hw){return pws->WSBeginPaint(hw);}

  void  SetPenStyle(int style, int i){ GWPenStyle[i].Style = style;}
  int   GetPenStyle(int i){return GWPenStyle[i].Style;}
  void  SetPenWidth(int width, int i){ GWPenStyle[i].Width = width;}
  int   GetPenWidth(int i){return GWPenStyle[i].Width;}
  void  SetPenColor(COLOR color, int i){ GWPenStyle[i].Color = color;}
  COLOR GetPenColor(int i){return GWPenStyle[i].Color;}
  void  SetBoxColor ( COLOR color ){ GWColorScheme.SetBox(color);}
  void  SetFillColor ( COLOR color ){ GWColorScheme.SetFill(color);}
  void  SetAxisColor ( COLOR color ){ GWColorScheme.SetAxis(color);}
  void  SetFrameColor ( COLOR color ){ GWColorScheme.SetFrame(color);}
  void  SetGridColor ( COLOR color ){ GWColorScheme.SetGrid(color);}

// Graph:
  double GWGetMathMinXG ( void ) { return ( GWMRG.GetMinX());}
  double GWGetMathMaxXG ( void ) { return ( GWMRG.GetMaxX());}
  double GWGetMathMinYG ( void ) { return ( GWMRG.GetMinY());}
  double GWGetMathMaxYG ( void ) { return ( GWMRG.GetMaxY());}
  void GWSetMathXG(double x, double y){GWMRG.SetMinX(x); GWMRG.SetMaxX(y);}
  void GWSetMathYG(double x, double y){GWMRG.SetMinY(x); GWMRG.SetMaxY(y);}
// Data:
  double GWGetMathMinXD ( void ) { return ( GWMRD.GetMinX());}
  double GWGetMathMaxXD ( void ) { return ( GWMRD.GetMaxX());}
  double GWGetMathMinYD ( void ) { return ( GWMRD.GetMinY());}
  double GWGetMathMaxYD ( void ) { return ( GWMRD.GetMaxY());}
  void GWSetMathXD(double x, double y){GWMRD.SetMinX(x); GWMRD.SetMaxX(y);}
  void GWSetMathYD(double x, double y ){ GWMRD.SetMinY(x); GWMRD.SetMaxY(y);}

  void GWSetMathAxisX ( double x ) { GWASX.MathAnotherAxisCoord = x;}
  void GWSetMathAxisY ( double y ) { GWASY.MathAnotherAxisCoord = y;}

  void GWSetStyleAxisX ( int x ) { GWASX.Style = x;}
  void GWSetStyleAxisY ( int x ) { GWASY.Style = x;}
char* GRAFWIN::GWGetTitle(void){return GWGraphTitle;}
void  GRAFWIN::GWSetTitle(char * Title){GWGraphTitle = Title;}

void GWPaint_yGraph (
        double * var
     , double   xMin
     , double   xMax
     , double   xStep
     , int      nPointsAll
     , int      nCurves
     , char     Title[]
       );
void GWPrepare_xyMath (
        double * xPoints
     , double * yPoints
     , int      nPoints
       );
void GWPaint_xyGraph (
        double * xPoints
     , double * yPoints
     , int      nPoints
     , char     Title[]
       );
void GWPrepareAll (char String[]);
void GWPrepareData (void);
void GWPrepareRegion ( char * Title );
void GWAxisX (void);
void GWAxisY (void);
void GRAFWIN::GWMoveTo( int x , int y );
void GWMoveToMath ( double x, double y );
void GWMoveToMath01 ( double x, double y );
BOOL GRAFWIN::GWGetCurrentPositionEx(POINT* point)
  {return GetCurrentPositionEx(pws->WShDC, point);}

void GRAFWIN::GWTextOut(char buf[]);

void GWLineMath ( double x1, double y1, double x2, double y2 );
void GWLinePix ( int x1, int y1, int x2, int y2 );
void GWLineRelPix ( int dx, int dy );
void GWMoveRelPix ( int dx, int dy );


void GWRectangle(PIXRECT * PixRect){
  Rectangle(pws->WShDC, PixRect->GetLeft(),  PixRect->GetTop(),
                       PixRect->GetRight(), PixRect->GetBottom());
}
HBRUSH GRAFWIN::GWBeginBrush ( int style , DWORD color );
void GRAFWIN::GWEndBrush (void);
UINT GRAFWIN::GWSetTextAlign(UINT fuAlign)
  {return SetTextAlign(pws->WShDC, fuAlign);}
void GWPaint_yCurveMath (
            double * y         // double * y
         , double   xBeg      // double   xBeg
         , double   xStep     // double   xStep
         , int      nPoints   // int      nPoints
           );
void GRAFWIN::GWPaint_xyPointsMath (
            double * X         // double * X
          , double * Y         // double * Y
          , POINT  * pt        // POINT * P
          , int      nPoints   // int      nPoints
          , int      iPen      //
          , int      Enclosed
           );
void GWPaint_xyCurveMath (double* x, double* y, int nPoints, int iPen);
void GWPaint_xyCurveMathm (double* x, double* y, int na, int nbp1, int iPen);
  PIXEL GRAFWIN::GWPixFromMathX(double a);
  PIXEL GRAFWIN::GWPixFromMathY(double a);
  PIXEL GRAFWIN::GWPixFromTipsX(TIPS x);
  PIXEL GRAFWIN::GWPixFromTipsY(TIPS y);
  void  GRAFWIN::GWPixFromTipsX(PIXEL* p, TIPS* t);
  void  GRAFWIN::GWPixFromTipsY(PIXEL* p, TIPS* t);
  void  GRAFWIN::GWPixRectFromTipsRect (PIXRECT* pr, TIPSRECT* tr);
  double GRAFWIN::GWMathFromPixX(PIXEL x);
  double GRAFWIN::GWMathFromPixY(PIXEL y);

// only for izolin2:
  typedef double G2FUNC ( int, int );
  typedef G2FUNC* PG2FUNC;
  typedef double G1FUNC ( int );
  typedef G1FUNC* PG1FUNC;

void GRAFWIN::GWMarkLine(int x, int y, int wid, int hig, char* Text, int iPen);

  int  izolin2Db (
       PG2FUNC  fVal      // double afVal ( int jy, int ix );
    , PG1FUNC  fxPoints  // double fxPoints (int ix); Lx <= ix <= Mx;
    , PG1FUNC  fyPoints  // double fyPoints (int jy); Ly <= jy <= My ;
    , int      Lx        // int Lx: low  index of afVal;
    , int      Mx        // int Mx: High index of afVal;
    , int      Ly        // int Ly: low  index of afVal;
    , int      My        // int My: High index of afVal;
    , PG1FUNC  fzPoints  // double fzPoints (iz); 0 <= iz <= izDim-1;
    , int      izDim     // int izDim : Number of izolines;
    , COLOR  * Colors    // int *  Colors : Colors[0]:Colors[nColors-1];
    , int      nColors   // int   nColors;
    , unsigned Regime    // IZOLINES || IZOREGIONS
      );

  int  izolin2Dc (
       PG2FUNC  fVal      // double fVal ( int iphi, int jrho );
    , PG1FUNC  frhoPoints // double frhoPoints ( jrho ); Lrho<=jrho<=Mrho;
    , PG1FUNC  fphiPoints // double fphiPoints ( iphi ); Lphi<=iphi<=Mphi;
    , int      Lrho      // int Lrho: low  inderho of fVal;
    , int      Mrho      // int Mrho: High inderho of fVal;
    , int      Lphi      // int Lphi: low  inderho of fVal;
    , int      Mphi      // int Mphi: High inderho of fVal;
    , PG1FUNC  fzPoints  // double fzPoints ( kz ); 0<=kz<=(izDim-1);
    , int      izDim     // int izDim : Number of izolines;
    , COLOR  * Colors    // int *  Colors : Colors[0]:Colors[nColors-1];
    , int      nColors   // int   nColors;
    , unsigned Regime    // IZOLINES || IZOREGIONS
      );
//  end izolin2
   int ioDatas (RWFUNC, FILE*);
};  //  GRAFWIN;

class GWIN
{
public:
  int nOfGraphics;
  PIXRECT UserRect;
public:
  WINSTON** ppWinSton;
public:
  void SetNOf(int n){nOfGraphics = n;}
  int  GetNOf(void){return nOfGraphics;}
  void GWIN::DestroyAll(void);
  void GWIN::CreateAll(HWND, HINSTANCE);
  void GWIN::ShowAll(int);
int GWIN::InvalWins();
void GWIN::ShowSet(int na, int nb, int nShow);
GWIN::GWIN(void){
  MessageBox(NULL, "GWIN: Wrong Constructor", "Error", MB_OK);
  exit(EXIT_FAILURE);
}
GWIN::GWIN(int nof){
  nOfGraphics = nof;
  ppWinSton = new WINSTON* [nOfGraphics];
}
GWIN::~GWIN(void)
{
  delete[] ppWinSton;
}
void GWIN::SetUserRect(double rows)
{
  int maxX = GetSystemMetrics (SM_CXFULLSCREEN);
  int maxY = GetSystemMetrics (SM_CYFULLSCREEN);
  int yCap = GetSystemMetrics (SM_CYCAPTION);
  int yMnu = GetSystemMetrics (SM_CYMENU);
  int ySts = yCap * rows + yMnu;
  UserRect.left   = 0;
  UserRect.right  = maxX;
  UserRect.top    = ySts-1;
  UserRect.bottom = maxY;
}

int GWIN::GWSetWinPixPos(int n)
{
  if (n<1) return TRUE;
  if (n>=nOfGraphics) return TRUE;
  return ppWinSton[n]->WSSetWinPixPos(UserRect);
}
int GWIN::GWSetWinsPixPos();
};

class REFRESHLIMITSWIN
{
private:
  int  nLiw;
  int* IsRefrLimits;
public:
  REFRESHLIMITSWIN::REFRESHLIMITSWIN(int n);
  REFRESHLIMITSWIN::~REFRESHLIMITSWIN(void);
  int REFRESHLIMITSWIN::ChkIndx(int& i);
  int REFRESHLIMITSWIN::ToRefreshLimits();
  int REFRESHLIMITSWIN::ToRefreshLimits(int i)
    {ChkIndx(i);IsRefrLimits[i]=TRUE;return TRUE;}
   int REFRESHLIMITSWIN::ToNotRefreshLimits(int i)
      {ChkIndx(i);IsRefrLimits[i]=FALSE;return TRUE;}
   int REFRESHLIMITSWIN::IsRefreshLimits(int i)
      {ChkIndx(i);return(IsRefrLimits[i]);}
};

//void AutoFontScale (FONTMODEL &, HDC, HWND);
void Calc_MinMax (double*, int, int, double*, double*);
void Calc_MinMaxm (double* arr, int na, int nbp1, double* ymin, double* ymax);

//void WindowsSetTile (GWIN ppGW, int nGraf1, int nGraf2 );
//void WindowsShowTile (GWIN ppGW, int, int );
//void WindowsSetCascade (GWIN ppGW, int nGraf1, int nGraf2 );
//void WindowsShowCascade (GWIN ppGW, int, int );

void TextOutMy ( HDC hdc, char buf[]);

//####################################################################\\
//####################################################################\\
//####################################################################\\

class DIM
{
private:
  int na, num, nb, nbp1;
public:
  DIM()            {Init();Set(0,1);}
  DIM(int b)       {Init();Set(0,b);}
  DIM(int a, int b){Init();Set(a,b);}
  int Getna(){return na;}
  int Getnb(){return nb;}
  int Getnum(){return num;}
  int Getnbp1(){return nbp1;}
  void Init(){na=0;num=1;}
  void Setna(int a){na=a;Prep();}
  void Setnum(int b){num=b;Prep();}
  void Set(int a, int b){Setna(a);Setnum(b);}
  void Prep(){nbp1=na+num; nb=nbp1-1;}
};
class DDIM
{
public:
  DIM dimy,dimx;
  DDIM(DIM dy, DIM dx){dimy=dy;dimx=dx;}
  DDIM(int nya, int ny, int nxa, int nx){dimy=DIM(nya,ny);dimx=DIM(nxa,nx);}
  DDIM(int ny, int nx){dimy=DIM(ny);dimx=DIM(nx);}
  DDIM(){dimy=DIM();dimx=DIM();}
};

const int wcmLINE  = 0;
const int wcmBRUSH = 1;
int dminmax(double *dfMin, double *dfMax, PDFUNCLL pfll, int nya, int ny, int nxa, int nx);
int dminmax(double *dfMin, double *dfMax, PDFUNCLL pfll, int ny, int nx);

class WINCOLORMAP
{
public:
  WINSTON* pws;
private:
  COLORREF wcmColor1;
  COLORREF wcmColor2;
  COLORREF wcmColorBack;
  COLORREF * wcmRGB;
	 int wcmNumOfColors;
	 double wcmfMin;
	 double wcmfMax;
  PDFUNCLL wcmpdfii;
  DIM wcmNY, wcmNX;
  double wcmyLength, wcmxLength, wcmxStep, wcmyStep, wcmScale, wcmScale1;
  RECT wcmr;
  RECT wcmrex;
  SSEGM wcmframe;
  RECT wcmDefRect;
  int wcmMode;
  int * px1y1;
  int * px1y2;
  int * px2y1;
  int * px2y2;
  int lWeightMax, lValueMax;
  int PixCellX, PixCellY;
  int x1, y1, x2, y2, x3, y3, x4, y4;
  int cx1y2, cx2y2, cx2y1, cx1y1;
  int wcmInterpFlag;
  int PixLenX, PixLenY, PixMinX, PixMinY;
  double rhomin, rhomax, phimin, phimax;
  double wcmPhi, wcmTheta;
  inline int ftx(double dx);
  inline int fty(double dy);
inline void wcmTransform(int m, int n, double z, double *px, double *py)
{
  *px = n * wcmxStep * cos(wcmPhi) - m * wcmyStep * sin(wcmPhi);
  *py = z * wcmScale1 * sin(wcmTheta)
	  + (n * wcmxStep * sin(wcmPhi) + m * wcmyStep * cos(wcmPhi)) * cos(wcmTheta);
}

inline void wcmTransform1(  double x, double y, double z
								  , double *px, double *py)
{
  *px = x * cos(wcmPhi) - y * sin(wcmPhi);
  *py = z * wcmScale1 * sin(wcmTheta)
	  + (x * sin(wcmPhi) + y * cos(wcmPhi)) * cos(wcmTheta);
}

public:
WINCOLORMAP::WINCOLORMAP()
{
  SetNX(1);
  SetNY(1);
  SetpFunc(NULL);
  wcmNumOfColors = 0;
//    pPaletteEntry = NULL;
  wcmRGB = NULL;
  SetColor1(RGB ( 0, 0, 0 ));
  SetColor2(RGB ( 255, 255, 255));
  wcmColorBack = RGB(255, 255, 255);
  SetNumOfColors(16);
  SetfMin(-1.0);
  SetfMax(1.0);
//  pws->WShDC = NULL;
  lWeightMax = 16000L;
  lValueMax = 16000L;
  Setwcmr(0, 0, 800, 600);
  Setwcmrex(0, 0, 800, 600);
  wcmframe = SSEGM(1,1,1,1);
  SetDefRect(0, 0, 24, 24);
  wcmSetMode(wcmLINE);
  wcmSetMode(wcmBRUSH);
  wcmSetPhi(30.0);
  wcmSetTheta(60.0);
  wcmSetxSize(1.0);
  wcmSetySize(1.0);
  wcmSetScale(1.0);
  wcmScale1 = 1.0;
  wcmxStep = 1.0;
  wcmyStep = 1.0;
  px1y1 = px2y1 = px2y2 = px1y2 = NULL;
//    opal = hpal = NULL;
  PixCellX = PixCellY = 2;
  wcmInterpFlag = TRUE;
}

WINCOLORMAP::~WINCOLORMAP(void)
{
//    delete[] pPaletteEntry;
  if (!wcmRGB) {delete[] wcmRGB; wcmRGB = NULL;}
}

void WINCOLORMAP::wcmSetAll(WINSTON* ptrws, PDFUNCLL pdfii, DDIM dim=DDIM(),
	PIXRECT pr = PIXRECT(0, 0, 36, 24),
	SSEGM frame = SSEGM(1,1,1,1),
	COLORREF c1 = RGB(0, 0, 0),
	COLORREF c2 = RGB(255, 255, 255),
	int ncols = 16)
{
  Link(ptrws);
  SetpFunc(pdfii);
  wcmNY=dim.dimy;
  wcmNX=dim.dimx;
  SetDefRect(pr);
  SetFrame(frame);
  SetColor1(c1);
  SetColor2(c2);
  SetNumOfColors(ncols);
}

void WINCOLORMAP::wcmSetAll(WINSTON* ptrws,
	PDFUNCLL pdfii, DDIM dim=DDIM(),
	SSEGM ssg = SSEGM(0, 36, 0, 24),
	SSEGM frame = SSEGM(1,1,1,1),
	COLORREF c1 = RGB(0, 0, 0),
	COLORREF c2 = RGB(255, 255, 255),
	int ncols = 16)
{
  Link(ptrws);
  SetpFunc(pdfii);
  wcmNY=dim.dimy;
  wcmNX=dim.dimx;
  SetDefRect(PIXRECT(ssg.l, ssg.t, ssg.r, ssg.b));
  SetColor1(c1);
  SetColor2(c2);
  SetNumOfColors(ncols);
  SetFrame(frame);
}

void WINCOLORMAP::SetDefRect(int l, int t, int r, int b)
{
  wcmDefRect.left   = l;
  wcmDefRect.right  = r;
  wcmDefRect.top    = t;
  wcmDefRect.bottom = b;
}

void WINCOLORMAP::SetDefRect(PIXRECT* ppr)
{
  wcmDefRect.left   = ppr->GetLeft();
  wcmDefRect.right  = ppr->GetRight();
  wcmDefRect.top    = ppr->GetTop();
  wcmDefRect.bottom = ppr->GetBottom();
}

void WINCOLORMAP::SetDefRect(PIXRECT pr)
{
  wcmDefRect.left   = pr.GetLeft();
  wcmDefRect.right  = pr.GetRight();
  wcmDefRect.top    = pr.GetTop();
  wcmDefRect.bottom = pr.GetBottom();
}

int WINCOLORMAP::Link(WINSTON* mws)
{
  if (!mws) return TRUE;
  pws = mws;
  return FALSE;
}
void WINCOLORMAP::SetNX(int nx){wcmNX.Setna(0); wcmNX.Setnum(nx);}
void WINCOLORMAP::SetNX(int nxa, int nx){wcmNX.Setna(nxa); wcmNX.Setnum(nx);}
void WINCOLORMAP::SetNY(int ny){wcmNY.Setna(0); wcmNY.Setnum(ny);}
void WINCOLORMAP::SetNY(int nya, int ny){wcmNY.Setna(nya); wcmNY.Setnum(ny);}
int  WINCOLORMAP::GetNX(){return wcmNX.Getnum();}
int  WINCOLORMAP::GetNY(){return wcmNY.Getnum();}
void     WINCOLORMAP::SetpFunc(PDFUNCLL pf){wcmpdfii = pf;}
PDFUNCLL WINCOLORMAP::GetpFunc(){return wcmpdfii;}
void WINCOLORMAP::SetNumOfColors(int ne);
int  WINCOLORMAP::GetNumOfColors(void){return wcmNumOfColors;}

void wcmSetxSize( double x ){wcmxLength = x;}
void wcmSetySize( double y ){wcmyLength = y;}
double wcmGetxSize(void){ return wcmxLength;}
double wcmGetySize(void){ return wcmyLength;}
void wcmSetScale( double y ){wcmScale = y;}
double wcmGetScale(void){ return wcmScale;}
void WINCOLORMAP::wcmSetMode(int nm)
  {
	 if (nm <= 0) wcmMode = wcmLINE;
	 if (nm >= 1) wcmMode = wcmBRUSH;
  }
  int  WINCOLORMAP::wcmGetMode(void){return wcmMode;}

  void   WINCOLORMAP::wcmSetPhi(double phi){wcmPhi=ToRadians(phi);}
  double WINCOLORMAP::wcmGetPhi(void){return ToDegrees(wcmPhi);}
  void   WINCOLORMAP::wcmSetTheta(double theta){wcmTheta=ToRadians(theta);}
  double WINCOLORMAP::wcmGetTheta(void){return ToDegrees(wcmTheta);}

  void WINCOLORMAP::SetfMin(double d){wcmfMin = d;}
  void WINCOLORMAP::SetfMax(double d){wcmfMax = d;}
  double WINCOLORMAP::GetfMin(void){return wcmfMin;}
  double WINCOLORMAP::GetfMax(void){return wcmfMax;}
int WINCOLORMAP::wcmMinMax(double *dfMin, double *dfMax)
{
  dminmax(dfMin, dfMax, wcmpdfii, wcmNY.Getna(), wcmNY.Getnum(), wcmNX.Getna(), wcmNX.Getnum());
  return FALSE;
}
int WINCOLORMAP::wcmMinMax()
{
//??? May be, simply &wcmfMin ?
  double dmin, dmax;
  wcmMinMax(&dmin, &dmax);
  SetfMin(dmin);
  SetfMax(dmax);
  return FALSE;
}

  void WINCOLORMAP::SetHDC(HDC x_hdc) {pws->WShDC = x_hdc;}
  HDC  WINCOLORMAP::wcmGetHDC(void) {return pws->WShDC;}
void WINCOLORMAP::SetFrame(SSEGM fr)
{
  wcmframe = fr;
}
void WINCOLORMAP::Setwcmr(int l, int t, int r, int b)
{
  wcmr.left = l;
  wcmr.top = t;
  wcmr.right = r;
  wcmr.bottom = b;
}
void WINCOLORMAP::Setwcmrex(int l, int t, int r, int b)
{
  wcmrex.left = l;
  wcmrex.top = t;
  wcmrex.right = r;
  wcmrex.bottom = b;
}
void WINCOLORMAP::SetRect(){ SetRect(pws->WSRect); }
void WINCOLORMAP::SetRect(RECT r){
  wcmrex.left   = r.left + wcmDefRect.left  *(r.right  - r.left)/pws->WSDefWid;
  wcmrex.right  = r.left + wcmDefRect.right *(r.right  - r.left)/pws->WSDefWid;
  wcmrex.top    = r.top  + wcmDefRect.top   *(r.bottom - r.top) /pws->WSDefHei;
  wcmrex.bottom = r.top  + wcmDefRect.bottom*(r.bottom - r.top) /pws->WSDefHei;
  wcmr.left   = wcmrex.left   + wcmframe.l;
  wcmr.top    = wcmrex.top    + wcmframe.t;
  wcmr.right  = wcmrex.right  - wcmframe.r;
  wcmr.bottom = wcmrex.bottom - wcmframe.b;
}
  RECT WINCOLORMAP::GetRect(void) {return wcmr;}

  void WINCOLORMAP::SetColor1(COLORREF c){wcmColor1 = c;}
  void WINCOLORMAP::SetColor2(COLORREF c){wcmColor2 = c;}
  void WINCOLORMAP::SetColorBack(COLORREF c){wcmColorBack = c;}
  COLORREF WINCOLORMAP::GetColor1(void){return wcmColor1;}
  COLORREF WINCOLORMAP::GetColor2(void){return wcmColor2;}
  COLORREF WINCOLORMAP::GetColorItem(int n) {return wcmRGB[n];}

  void WINCOLORMAP::PrepareColor12(int& Red1, int& Green1, int& Blue1,
                                   int& Red2, int& Green2, int& Blue2 );
//  void WINCOLORMAP::PreparePalette(void);
  void WINCOLORMAP::PrepareRGB(void);
  void WINCOLORMAP::AllocCellInterpolant();
  void WINCOLORMAP::DeAllocCellInterpolant(void);
  void WINCOLORMAP::PaintCellBitmap();
  int WINCOLORMAP::PaintColorMap2Da();
  void WINCOLORMAP::gline_w ( int xa, int ya, int xb, int yb );
//  void WINCOLORMAP::OutText(char* txt){OutTextXY (pws->WShDC, );};
int WINCOLORMAP::PaintIzolin2Da(PDFUNCLL pfll, int ndpy, int ndpx, double dfMin, double dfMax);
int WINCOLORMAP::PaintIzolin2Da();

int WINCOLORMAP::PaintSurface2Da(PDFUNCLL pfll, int ndy, int ndx, double dfMin, double dfMax);
int WINCOLORMAP::PaintSurface2Da();

int WINCOLORMAP::CallSurface2Da(){
  SetRect();
  PaintFrameRect();
  wcmMinMax();
  wcmSetPhi(30.0);
  wcmSetTheta(30.0);
  PaintSurface2Da();
  return FALSE;
}
int WINCOLORMAP::CallSurface2Da(int ny, int nx){
  SetNY(ny);
  SetNX(nx);
  double dfmin, dfmax;
  SetRect();
  PaintFrameRect();
  wcmMinMax(&dfmin, &dfmax);
  SetfMin(dfmin);
  SetfMax(dfmax);
  wcmSetPhi(30.0);
  wcmSetTheta(30.0);
  PaintSurface2Da( wcmpdfii, ny, nx, dfmin, dfmax);
  return FALSE;
}

int WINCOLORMAP::CallIzolin2Da(){
  SetRect();
  PaintFrameRect();
  wcmMinMax();
  PaintIzolin2Da();
  return FALSE;
}
int WINCOLORMAP::CallIzolin2Da(int ny, int nx){
  SetNY(ny);
  SetNX(nx);
  double dfmin, dfmax;
  SetRect();
  PaintFrameRect();
  wcmMinMax(&dfmin, &dfmax);
  SetfMin(dfmin);
  SetfMax(dfmax);
  PaintIzolin2Da( wcmpdfii, ny, nx, dfmin, dfmax);
  return FALSE;
}


int WINCOLORMAP::PaintIzolin2Dc(
  PDFUNCLL pfllNew,
  double   dfMinNew, double dfMaxNew,
  PDFUNCLL pfllOld,
  double   dfMinOld, double dfMaxOld,
  PDFUNCL  frhoPoints,
  PDFUNCL  fphiPoints,
  int Lrho, int Mrho, int Lphi, int Mphi );

int WINCOLORMAP::PaintColorMap2Dc(PDFUNCLL pfll, PDFUNCL frhoPoints,
	 PDFUNCL fphiPoints, int Lrho, int Mrho, int Lphi, int Mphi);
  void WINCOLORMAP::PaintFrameRect()
  {
	 Rectangle( pws->WShDC, wcmrex.left, wcmrex.top, wcmrex.right, wcmrex.bottom);
  }
  void WINCOLORMAP::PaintFrameOnly()
  {
	 MoveToEx( pws->WShDC, wcmrex.left,  wcmrex.top, NULL);
	 LineTo  ( pws->WShDC, wcmrex.right, wcmrex.top);
	 LineTo  ( pws->WShDC, wcmrex.right, wcmrex.bottom);
	 LineTo  ( pws->WShDC, wcmrex.left,  wcmrex.bottom);
	 LineTo  ( pws->WShDC, wcmrex.left,  wcmrex.top);
  }

void WINCOLORMAP::CallColorMap2Da(){
  SetRect();
  PaintFrameRect();
  wcmMinMax();
  PaintColorMap2Da();
}

//####################################################################\\
int WINCOLORMAP::Line1D(PDOUBLE YArray, PDOUBLE  XArray,
                          int nMin,  int nMax, COLOR LineColor, double Coef=1);

//####################################################################\\
//eeee
//####################################################################\\
int WINCOLORMAP::PaintTraj2D(PPDOUBLE xCoord, PPDOUBLE  yCoord,
double Xmin,  double Xmax, double Ymin, double Ymax, PINT kSteps, int mode=0);

int WINCOLORMAP::PaintTraj3D(PPDOUBLE xCoord, PPDOUBLE  yCoord, PPDOUBLE  zCoord,
double Xmin,  double Xmax, double Ymin, double Ymax, double Zmin, double Zmax);

};

//####################################################################\\
typedef WINCOLORMAP* PWCM;
typedef PWCM* PPWCM;
PPWCM AllocWCM2D (int rows, int columns);
void DeAllocWCM2D (PPWCM& x, int rows);
void ReAllocWCM2D (PPWCM& x, int rows, int columns);
void ProcessWCM2D (PPWCM& x, int rows, int columns, int what);
PWCM AllocWCM1D (int rows);
void DeAllocWCM1D(PWCM& x);
void ReAllocWCM1D(PWCM& x, int rows);
void ProcessWCM1D(PWCM& x, int rows, int what);


// Old variant:
void WinDrawSurface(HDC, RECT *, DOUBLE2DM *, int);
// Modified: to PDFUNCLL instead of  DOUBLE2DM:
int PaintSurface2D (HDC, RECT *, int mode, PDFUNCLL pfll, int ndpy, int ndpx,
	  double dfMin, double dfMax );
//####################################################################\\
//####################################################################\\
//####################################################################\\

//####################################################################\\
//                                                                    \\
//      ENDFILE:   grafwin.h                                          \\
//                                                                    \\
//####################################################################\\

