
//####################################################################=
//####################################################################=
//                                                                    =
//     FILE:     standard.h, common                                           =
//                                                                    =
//####################################################################=
//####################################################################=

extern const double PI;
extern const double Pi;
extern const double pi;
extern const double Degree;
extern int membyte;

inline double ToRadians(double phi){return phi*Degree;}
inline double ToDegrees(double phi){return phi/Degree;}

const int STD_ALLOC   = 1;
const int STD_DEALLOC = 2;
const int STD_REALLOC = 3;

const int stdbuflen = 128;
extern char stdbuf0[stdbuflen];
extern char stdbuf1[stdbuflen];
extern char stdbuf2[stdbuflen];

typedef double DOUBLE;
//??? typedef complex* PCOMPLEX;
typedef DOUBLE* PDOUBLE;
typedef PDOUBLE* PPDOUBLE;
typedef int * PtrINT;
typedef PtrINT * PPINT;
typedef unsigned char UCHAR;
typedef UCHAR * PUCHAR;
typedef PUCHAR * PPUCHAR;
typedef short SHORT;
typedef SHORT * PSHORT;
typedef PSHORT * PPSHORT;
typedef unsigned short USHORT;
typedef USHORT * PUSHORT;
typedef PUSHORT * PPUSHORT;

typedef POINT * POINT1D;

typedef double DFUNCLL ( int , int );
typedef DFUNCLL* PDFUNCLL;
typedef double DFUNCL ( int );
typedef DFUNCL* PDFUNCL;

const int  ERROR_YES = 1;
const int  ERROR_NOT = 0;

  double distance2D ( double x1 , double y1 , double x2 , double y2 );
  int nfloor ( double d ) ;
  long int lfloor ( double d );
  int nceil ( double d ) ;
  long int lceil ( double d );

   double  dmax  ( double value1 , double value2 );
   double  dmin  ( double value1 , double value2 );
   int     imax  ( int    value1 , int    value2 );
   int     imin  ( int    value1 , int    value2 );

class DOUBLE1DM{
private:
  int nx;
  PDOUBLE px;
  void DOUBLE1DM::D1DCheckIndex(int i);
public:
  DOUBLE1DM(){px = NULL; nx = 0;}
  DOUBLE1DM(int nn){
    px = NULL;
    D1DAlloc(nn);
  }
  ~DOUBLE1DM(){
    D1DDealloc();
  }
  void D1DDealloc();
  void D1DAlloc(int nn);
public:
   inline DOUBLE & operator[](int i);
   int    Getnx() {return nx;}
   void   D1DMinMax(double * dmin, double * dmax);
 };

//####################################################################
//####################################################################

class DOUBLE2DM{
private:
  int D2Dny;
  int D2Dnx;
  PPDOUBLE D2Dxy;
  void D2DCheckIndexY(int i);
public:
  DOUBLE2DM() {D2Dxy = NULL; D2Dnx = D2Dny = 0;}
  DOUBLE2DM(int _ny, int _nx){
    D2Dxy = NULL;
    D2DAlloc(_ny, _nx);
  }
  ~DOUBLE2DM(){
    D2DDealloc();
  }
  void D2DDealloc();
  void D2DAlloc(int _ny, int _nx);
public:
  inline PDOUBLE & operator[](int y);// {return D2Dxy[y];}
  int GetDimX() {return (D2Dnx);}
  int GetDimY() {return (D2Dny);}
  void D2DMinMax(double * dmin, double * dmax);
  void DOUBLE2DM::InvertX(void);
  void DOUBLE2DM::InvertY(void);
  void DOUBLE2DM::InvertZ(void);
};

void DFLLMinMax( PDFUNCLL pfll, int ndy, int ndx, double *min, double *max);

//####################################################################
PPDOUBLE AllocDouble2D (int rows, int columns);
void DeAllocDouble2D (PPDOUBLE& x, int rows);
void ReAllocDouble2D (PPDOUBLE& x, int rows, int columns);
void ProcessDouble2D (PPDOUBLE& x, int rows, int columns, int what);
void ProcessDouble2D (PPDOUBLE& x, PPDOUBLE& y, int rows, int columns, int what);
void ProcessDouble2D (PPDOUBLE& x, PPDOUBLE& y, PPDOUBLE& z, int rows, int columns, int what);
void ProcessDouble2D (PPDOUBLE& x, PPDOUBLE& y, PPDOUBLE& z, PPDOUBLE&, int rows, int columns, int what);
void ProcessDouble2D (PPDOUBLE& x, PPDOUBLE& y, PPDOUBLE& z, PPDOUBLE&, PPDOUBLE&, int rows, int columns, int what);
void ProcessDouble2D (PPDOUBLE& x, PPDOUBLE& y, PPDOUBLE& z, PPDOUBLE&, PPDOUBLE&, PPDOUBLE&, int rows, int columns, int what);

/*
PCOMPLEX AllocComplex1D (int rows);
void DeAllocComplex1D(PCOMPLEX& x);
void ReAllocComplex1D(PCOMPLEX& x, int rows);
void ProcessComplex1D(PCOMPLEX& x, int rows, int what);
void DeAlloc(PCOMPLEX& x);
void ReAlloc(PCOMPLEX& x, int rows);
void Process(PCOMPLEX& x, int rows, int what);
*/

PDOUBLE AllocDouble1D (int rows);
void DeAllocDouble1D(PDOUBLE& x);
void ReAllocDouble1D(PDOUBLE& x, int rows);
void ProcessDouble1D(PDOUBLE& x, int rows, int what);
void ProcessDouble1D(PDOUBLE& x, PDOUBLE& y, int rows, int what);
void ProcessDouble1D(PDOUBLE& x, PDOUBLE& y, PDOUBLE& z, int rows, int what);
void ProcessDouble1D(PDOUBLE& x, PDOUBLE& y, PDOUBLE& z, PDOUBLE& t, int rows, int what);
void ProcessDouble1D(PDOUBLE& x, PDOUBLE& y, PDOUBLE& z, PDOUBLE& t, PDOUBLE& s, int rows, int what);
void ProcessDouble1D(PDOUBLE& x, PDOUBLE& y, PDOUBLE& z, PDOUBLE& t, PDOUBLE& s, PDOUBLE& r, int rows, int what);

PtrINT AllocInt1D ( int rows );
void DeAllocInt1D ( PtrINT& x );
void ReAllocInt1D ( PtrINT& x, int rows);
void ProcessInt1D ( PtrINT&, int rows, int what);
void ProcessInt1D ( PtrINT&, PtrINT&, int rows, int what);
void ProcessInt1D ( PtrINT&, PtrINT&, PtrINT&, int rows, int what);
void ProcessInt1D ( PtrINT&, PtrINT&, PtrINT&, PtrINT&, int rows, int what);
void ProcessInt1D ( PtrINT&, PtrINT&, PtrINT&, PtrINT&, PtrINT&, int rows, int what);
void ProcessInt1D ( PtrINT&, PtrINT&, PtrINT&, PtrINT&, PtrINT&, PtrINT&, int rows, int what);
void ProcessInt1D ( PtrINT&, PtrINT&, PtrINT&, PtrINT&, PtrINT&, PtrINT&, PtrINT&, int rows, int what);

PPINT   AllocInt2D (int rows, int columns);
void  DeAllocInt2D (PPINT & x, int rows);
void  ReAllocInt2D (PPINT & x, int rows, int columns);
void  ProcessInt2D (PPINT & x, int rows, int columns, int what);

PUCHAR AllocChar1D (int rows);
void DeAllocChar1D (PUCHAR & x);
void ReAllocChar1D (PUCHAR & x, int rows);
void ProcessChar1D (PUCHAR & x, int rows, int what);

PPUCHAR AllocChar2D (int rows, int columns);
void  DeAllocChar2D (PPUCHAR & x, int rows);
void  ReAllocChar2D (PPUCHAR & x, int rows, int columns);
void  ProcessChar2D (PPUCHAR & x, int rows, int columns, int what);

PPSHORT AllocShort2D (int rows, int columns);
void  DeAllocShort2D (PPSHORT & x, int rows);
void  ReAllocShort2D (PPSHORT & x, int rows, int columns);
void  ProcessShort2D (PPSHORT & x, int rows, int columns, int what);

PPUSHORT AllocUShort2D (int rows, int columns);
void  DeAllocUShort2D (PPUSHORT & x, int rows);
void  ReAllocUShort2D (PPUSHORT & x, int rows, int columns);
void  ProcessUShort2D (PPUSHORT & x, int rows, int columns, int what);

POINT1D AllocPoint1D ( int rows );
void DeAllocPoint1D ( POINT1D & x );


inline double scdr(double x){return(x*x);}

/*
PCOMPLEX AllocComplex1D(int rows);
void DeAllocComplex1D(PCOMPLEX& x);
void ReAllocComplex1D(PCOMPLEX& x, int rows);
void ProcessComplex1D(PCOMPLEX& x, int rows, int what);
*/

extern const double sqrt3;
double modRandom01();
extern const int GAUSSNUMBER;
extern const int GAUSSNUMBER2;
extern const double dGAUSSNUMBER;
double Gauss01b();
inline double Random01(){return ( double(rand()) / double(RAND_MAX));}
inline double Random11(){return ( 2.0*Random01() - 1.0);}
inline double Random33(){return ( sqrt3*Random11());}
inline double RandomAB(double A, double B){return(A+(B-A)*Random01());}
//???
extern double rt1;
inline double Gauss01a()
{
  rt1 = Random11();
  return ( rt1*(1.253 + rt1*rt1*(0.3 + rt1*rt1*(0.5+rt1*rt1*0.5))));
}


int use(int x);
int use(double x);
int use(double x, double y);
int use(double x, double y, double z);
inline double lg(double x){return log(double(x))/log(double(10));}
//####################################################################=
//####################################################################=
//                                                                    =
//  ENDFILE:     standard.h                                           =
//                                                                    =
//####################################################################=
//####################################################################=

